// sbmp.cpp:  member_functions for sprite file reader
// updated by Lucas Keyes
// January 17, 2002

#include "sbmp.h"

BOOL SpriteBmp_Object::draw(LPDIRECTDRAWSURFACE surface, int width, int ht, int x, int y) {

	DDSURFACEDESC ddsd;		// direct draw surface descriptor
	BYTE *dest, *src;		// destination and source pointers

	// init surface descriptor
	memset(&ddsd,0,sizeof(DDSURFACEDESC));
	ddsd.dwSize=sizeof(ddsd);

	// lock down surface
	if (FAILED(surface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL)))
		return FALSE;
	// calculate addresses and width
	dest = (BYTE*)ddsd.lpSurface;		// destination pointer
	src = b_Image+ ((BmpFileInfo.biHeight-1-y)*BmpFileInfo.biWidth+x); // source pointer

	// move data to surface
	for (int i=0; i<ht; i++){	// for each row
		memcpy(dest,src,width);	// copy
		dest+=ddsd.lPitch; src-=BmpFileInfo.biWidth;	// next row
	}

	// clean up and return
	surface->Unlock(NULL);
	return TRUE;
} // draw