// bsprite.h

// header file for base sprite class

// Updated by Lucas Keyes
// January 17, 2002

#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

#include "sbmp.h"

#ifndef __BSPRITE__	// ensures that there is only one instance of 
#define __BSPRITE__	// bsprite.h declared, preventing run-time error

class SpriteImg_Object { // simplest sprite
    protected:    // protected variables allow inheritance for derived classes
        LPDIRECTDRAWSURFACE *s_lpDDImage;	// sprite image on DD surface
        int s_frameCount;                       // how many frames used in sprite
        int s_width, s_height;                  // dimensions of sprite images
        void CreateSurfaces();                  // create DD surfaces

    public:
        SpriteImg_Object(int frames, int w, int h);  // constructor 
        ~SpriteImg_Object();                         // destructor
        BOOL load(SpriteBmp_Object *image, int frame, 
                  int x, int y);		     // load sprite image from raw bitmap data
        virtual void draw(int frame, int x, int y, 
                          LPDIRECTDRAWSURFACE destination);   // draw sprite
        void Release();    // release direct draw surfaces
        BOOL Restore();    // restore surfaces
        int frame_count(); // return number of frames
        int height();      // return height
        int width();       // return width

		BOOL load(char *filename,int x,int y, 
					LPDIRECTDRAWPALETTE palette1,
					LPDIRECTDRAWPALETTE palette2);
};

#endif
