// Lucas Keyes
// DirectX Manager
// Class responsible for holding and maintaining all high-level
// DirectX variables, improves program readability
#include "defines.h"

//#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include <fcntl.h>


#include <ddraw.h>
#include <dsound.h>
#include <dinput.h>


#ifndef __DX_MANAGER_H__
#define __DX_MANAGER_H__


class DirectXManagerObject {

public:
	LPDIRECTDRAW lpdirectdrawobj;			// the main DirectDraw
											// object

		LPDIRECTDRAWSURFACE lpddsprimary;	// the primary surface
		LPDIRECTDRAWSURFACE lpddsecondary;	// the video backbuffer

		// palettes for 8 bit graphics
		LPDIRECTDRAWPALETTE lpddsprimarypalette;
		LPDIRECTDRAWPALETTE lpddsecondarypalette;

		// clipper to allow clipped objects
		LPDIRECTDRAWCLIPPER lpddsclipper;


	LPDIRECTSOUND lpdirectsoundobj;		// the main DirectSound
										// object

	LPDIRECTINPUT lpdirectinputobj;		// the main DirectInput
										// object

	LPDIRECTINPUTDEVICE lpdinputkey;	// the keyboard as a
										// Game Input Device

	// Methods
	DirectXManagerObject();

	LPDIRECTDRAWPALETTE CreatePalette(LPDIRECTDRAWSURFACE surface);
	int createdirectdraw(int, int, int, HWND );
	int createsurfaces();
	void destroySurfaces();
	void shutdownddraw();

	int createdinputKeyboard(HINSTANCE, HWND);

	int createdirectsound(HWND);

	void shutdowndInputKey();
	void shutdowndsound();

	bool startupDirectX(HINSTANCE, HWND);
	bool shutdownDirectX();

	void clearsecsurface();
	void Flip();



};

#endif


