// Lucas Keyes
// source code file for mapGrid object

#include "mapgrid_obj.h"

mapGrid_Object::mapGrid_Object() {

	for (int x = 0; x < MAXMAPX; x++) 
		for (int y = 0; y < MAXMAPY; y++)
			mapGridArray[y][x] = BLACK;

	size_x = size_y = 0;

}

short mapGrid_Object::colorAt(int x, int y) {

	return mapGridArray[y][x];
}

void mapGrid_Object::copyqbintomap(QuadBlock QB) {
		// this function goes through the space description array of the quadblock
	// and copies the color value into the mapGrid array at the appropriate
	// grid position



		for (int ypos = 0; ypos <= QB.spaceArray[QB.currentpos].maxY; ypos++)	// run through rows
		for (int xpos = 0; xpos <= QB.spaceArray[QB.currentpos].maxX; xpos++) // run through columns
			if (QB.currentColorAt(xpos,ypos) != BLACK)
				mapGridArray[QB.gridY+ypos][QB.gridX+xpos] = QB.currentColorAt(xpos,ypos);

}


void mapGrid_Object::clearQuadBlockPos(QuadBlock QB) {
		// this function searches the Quadblock's descriptor array and compar  es
	// it to what is corresponding in the mapGrid.  If there is a non-black
	// space in the QB array, it clears out that space in the mapGrid.
   
	for (int xpos = 0; xpos <= QB.spaceArray[QB.currentpos].maxX; xpos++) { // run through the Quadblock's columns

  	   	for (int ypos = 0; ypos <= QB.spaceArray[QB.currentpos].maxY;ypos++){ // run through the Quadblock's rows
		
		 	if (QB.currentColorAt(xpos,ypos) != BLACK)	// if non-black square in QB, make black in Grid
				mapGridArray[QB.gridY+ypos][QB.gridX+xpos] = BLACK;
		}
	}

}

bool mapGrid_Object::checkfilledRows(int filledrows[], int *numfilled) {
	// this function scans through the array from top to  bottom looking for 
// non-black squares. If the number of non-black squares in a row is equal
// to the number of squares in a row, then the row is filled.  the row value
// is stored in the filled row array and the number of filled rows is 
// incremented.


	int filledinrow = 0;
	bool rowfilled = false;
	int index = 0;


	*numfilled = 0;		// initialize the number of non-filled rows

	for (int ypos = 0; ypos < MAXMAPY; ypos++) {
		// scan one row at a time

		for (int xpos = 0; xpos < MAXMAPX; xpos++) {
			// traverses through the row looking for non-black squares

			if (mapGridArray[ypos][xpos] != BLACK) // if a colored block is occupying the space
				filledinrow++;		// increment the number filled in the row
		}

		if (filledinrow == MAXMAPX) {
			// if the number of filled squares = total squares in row, the
			// function will return true, and the row value is stored.

			rowfilled = true;
			filledrows[*numfilled] = ypos;
			*numfilled=*numfilled+1;
			
		}
		filledinrow = 0; 


	}
	return rowfilled;

}

void mapGrid_Object::deleteOneRow(int currentrow) {
	// this function simulates the deletion of a row of values in mapGrid array
	// by shifting all rows above the specified row (currentrow) down one.  
	// it resets the top row by filling it with zero values.

	for (int row = currentrow; row >=1; row-- )			// run through rows above current row
		for (int column = 0; column < MAXMAPX; column++ )	// run through columns
			mapGridArray[row][column] = mapGridArray[row-1][column];	// place color of current space in 
															// mapGrid to the one above it

	setTopRowBlack();			

}

void mapGrid_Object::setTopRowBlack() {
		// this function sets the top row to all BLACK values.

	for (int column = 0; column < MAXMAPX; column++)	// run through columns of first row
		mapGridArray[0][column] = BLACK;

}

bool mapGrid_Object::checkOverlap(QuadBlock QB) {
	// this function tests for a potential overlap of blocks by first traversing
	// through the QuadBlock's space desc array looking for a non-black space
	// and seeing if a non-black space occupies the same potential block in the
	// map.  If so, there is an overlap and the function returns true, otherwise
	// there is no overlap and the function returns false.

	bool temp = false;
	int xpos = 0;
	int ypos;

	do {			// run thourgh columns of the current Quadblock
		ypos = 0;	// set row equal to zero	
		do {		// runm through rows of the current Quadblock
			if ((QB.currentColorAt(xpos,ypos)!=BLACK)	// if non-black space in Quadblock
				&&(mapGridArray[QB.gridY + ypos][QB.gridX+xpos]!=BLACK)) {	// matches a non-black space in the GRID

				temp = true;	// overlap equals true
				break;			// stop testing
			}
			ypos++;	// increment row number
		} while (ypos <= QB.spaceArray[QB.currentpos].maxY);
		xpos++;		// increment column number
	} while (xpos <= QB.spaceArray[QB.currentpos].maxX);
	return temp;
}