// objects.h:  header file for CObject class

// updated Lucas Keyes
// January 17, 2002

#ifndef __OBJECTS__
#define __OBJECTS__

#include "bsprite.h"

class Game_Object{  // class for an object in the game
  private:
      int gX, gY;   // current location
      int g_Xspeed, g_Yspeed;  // current speed
      int g_lastXMoveTime;     // last time the object moved
      SpriteImg_Object *g_Sprite;  // pointer to sprite

  public:
      Game_Object();    // constructor
      void draw(int frame,LPDIRECTDRAWSURFACE surface);  // draw
      void create(int x, int y, int xspeed, int yspeed,
                  SpriteImg_Object *sprite);  // create instance
      void accelerate(int xdelta, int ydelta = 0); // change speed
      void move();    // make a move depending on time and speed
};

#endif