#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <OBJBASE.H>

#include <ddraw.h>  // directX includes
#include <dinput.h>

// custom includes
#include "defines.h"
#include "quadblock.h"
#include "program_methods.h"
#include "soundobject.h"
#include "sbmp.h"
#include "bsprite.h"
#include "csprite.h"
#include "timer.h"
#include "dxmanager.h"
#include "SpriteImg_ManagerObject.h"
#include "mapgrid_obj.h"
#include "snd_managerobj.h" 

extern HWND main_window_handle;
extern HINSTANCE main_instance_handle;

extern QuadBlock quadarray[8];	// holds the array of colored blocks

extern int total_lines;	// keeps a tab on the total number of lines
						// cleared by the player.

extern int inputswitch;;	// slows down the rate at which the player
						// can move left or right

extern DWORD next_down_time;	// holds the time to control the falling rate of the blocks
extern DWORD next_rotate_time; // holds the time to control the spinning rate of the blocks

extern int numlife;

extern SpriteBmp_Object *quadblock_bmp;

extern SpriteImg_ManagerObject *sprite_bag;

extern CTimer Timer;

extern DirectXManagerObject DXManager;

extern mapGrid_Object mapGridArray;

extern Sound_ManagerObject *sounds_bag;

//------------------------------------------------------------------------------

bool loadBlocks() {

	quadblock_bmp = new SpriteBmp_Object();

	quadblock_bmp->load("quadblocks2.bmp");

	sprite_bag->create(BLOCKS,NUMBLOCKS,QBWIDTH,QBHEIGHT,true);

	for (int i = 0; i < NUMBLOCKS; i++) 
		sprite_bag->load(BLOCKS,quadblock_bmp,i,23*i + 2, 4 );		

	delete quadblock_bmp;

	return(true);
}

//--------------------------------------------------------------------------

bool loadScore() {

	SpriteBmp_Object *tmpbmp = new SpriteBmp_Object();

	tmpbmp->load("score.bmp");

	sprite_bag->create(NUMARRAY,MAXNUMS,NUMWIDTH,NUMHEIGHT,true);

	for (int i = 0; i < MAXNUMS; i++) 
		sprite_bag->load(NUMARRAY,tmpbmp,i,i*23 + 2, 4 );		
	
	delete tmpbmp;

	return(true);
}

void drawTextinGDI( char * text, int x, int y, COLORREF color) {


	HDC xdc; // the working dc
	int length;
	// get the dc from secondary back buffer
	DXManager.lpddsecondary->GetDC(&xdc);

	// set the colors for the text up
	SetTextColor(xdc, color);

	// set background mode to transparent so black isn't copied
	SetBkMode(xdc, TRANSPARENT);

	// draw the score in lower right corner
	length = strlen(text);
	TextOut(xdc,x,y,text,length);

	// release the dc
	DXManager.lpddsecondary->ReleaseDC(xdc);

}

void drawloadScreen() {

	DXManager.clearsecsurface();
	drawTextinGDI("Loading...",20,20,RGB(255,255,255));

	DXManager.lpdirectdrawobj->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
	while(DXManager.lpddsprimary->Flip(NULL,DDFLIP_WAIT)!=DD_OK);
}

void createQuadBlocks() {

	quadarray[0].createqbA();
	quadarray[1].createqbB();
	quadarray[2].createqbC();
	quadarray[3].createqbD();
	quadarray[4].createqbE();
	quadarray[5].createqbF();
	quadarray[6].createqbG();
}

//------------------------------------------------------------------------------

void putTopBlockinGrid(QuadBlock &QB) {
	// put the quadblock in the top of the grid

	QB.gridY = 0;
	QB.gridX = 4;

	mapGridArray.copyqbintomap(QB);

}

//-------------------------------------------------------------------------

void drawmapGridintoSec() {

	for (int y = 0; y < MAXMAPY; y++) 
		for (int x = 0; x < MAXMAPX; x++)

			sprite_bag->draw(BLOCKS,mapGridArray.colorAt(x,y),gridXtoScreenX(x),
						gridYtoScreenY(y), DXManager.lpddsecondary);
			
}	// end drawmapGridintoSec

//--------------------------------------------------------------------------------

int processOneQuadBlock(QuadBlock &QB, int score[MAXSCOREPOS],QuadBlock nextblock) {
	
	int playerinput; 
	int success = 2;
	bool collision = false;

	do { 
		playerinput = processPlayerInput(QB);
		if (playerinput == NOINPUT) {
			if (current_time() >= next_down_time) {
			collision = !(processMove(QB,DOWN,UP)); 
			next_down_time = current_time() + new_next_time(total_lines);
			}
		
		}
		 if ((playerinput != SHUTDOWN))
			animateQuadBlock(nextblock,score);
	} while (((!collision))&&(playerinput != SHUTDOWN)); 

	if (playerinput == SHUTDOWN)
		success = END_GAME;
	else if ((collision) && (QB.gridY == 0))
		success = END_LIFE;

	return success;
}

//------------------------------------------------------------------------------

int processPlayerInput(QuadBlock &QB) {

	int choice;

	choice = readPlayerInput();

	switch (choice) {

	case LEFT:
		processMove(QB,LEFT,RIGHT);
		break;
	case RIGHT:
		processMove(QB,RIGHT,LEFT);
		break;
	case DOWN:
		processMove(QB,DOWN,UP);
		break;
	case CLOCKWISE:
		if(!(processMove(QB,CLOCKWISE,COUNTERCLOCKWISE)))
			return COLLISION;
		break;
	case COUNTERCLOCKWISE:
		processMove(QB,COUNTERCLOCKWISE,CLOCKWISE);
		break; 
	case SHUTDOWN:
		return SHUTDOWN;
		break;
	case PAUSE:
		pauseGame();
		break;
	default: 
		return NOINPUT;
		break; 
	} 

}

//------------------------------------------------------------------------------------------

int readPlayerInput() {

	UCHAR keystate[256];

	if ((DXManager.lpdinputkey->GetDeviceState(256,(LPVOID)keystate))!=DI_OK)
		return(0); 

	if (keystate[DIK_RIGHT]) {
		if (inputswitch == 0) {
			inputswitch = 1;
			return RIGHT;
		}
	}
	if (keystate[DIK_LEFT]) {
		if (inputswitch == 0) {
			inputswitch = 1;
			return LEFT;
		}
	}
	if (keystate[DIK_DOWN]) {
			return DOWN;
		}
	if (keystate[DIK_SPACE]) {

		if (current_time() > next_rotate_time) {
			next_rotate_time = current_time() + SPACE_ROTATE_CONSTANT;
			return CLOCKWISE;
		}
	}
	if (keystate[DIK_ESCAPE]) {
	
			return SHUTDOWN;
		
	}
	if (keystate[DIK_RETURN]) {
		if (inputswitch == 0) {
			inputswitch = 1;
			return PAUSE; 
		} 
		
	}
	else {
		inputswitch = 0;
		return NOINPUT;  
	}
  
	return(0);
}

//------------------------------------------------------------------------------


bool processMove(QuadBlock &QB, int movement, int opposite) {
   	// this function moves a quadblock down by first clearing it out of the
	// mapGrid, setting the new x and y positions in the quadblock,
	// and then testing whether there will be any problems moving it.
	// if there are problems, then it will set the xy positions back and return
	// false for success, otherwise it returns true.  Before exiting, however,
	// it recopies the quadblock back into the mapGrid. 

	bool success;

	mapGridArray.clearQuadBlockPos(QB);	// clear QuadBlock out of the grid
				
	QB.setnewXYPosition(movement);				// change the x & y values of QuadBlock
	if (checkforProblems(QB)) {			// check for problems, if there is then
		QB.setnewXYPosition(opposite);				// change x & y values back
		success = false;						// return false for success of movement
	}
	else   
		success = true;							// return true for success of movement

	mapGridArray.copyqbintomap(QB);
						// copy the Quadblock back into the map
	
	return success;
}

//-------------------------------------------------------------------------------

bool checkforProblems(QuadBlock QB) {
	// this code checks to see if the quadblock can be copied int o  the 
	// mapGrid by testing if the QuadBlock is in bounds, and then  testing
	// for a potential overlap of the QuadBlocks.  If there is an overlap or
	// the quadblock is not in bounds, it returns true for problems and therefore
	// the quadblock cannot be copied into the mapGrid

	bool problems = false;

	if (!(QB.inBounds()))	// check if QuadBlock is in bounds
		problems = true;
	            
		else if (mapGridArray.checkOverlap(QB)) // check for overlapping in the grid
		problems = true;
	return problems;
}

//-------------------------------------------------------------------------------

void animateQuadBlock(QuadBlock QB, int score[MAXSCOREPOS]) {

	DXManager.clearsecsurface();

	sprite_bag->draw(MENU,0,0,0,DXManager.lpddsecondary);

	drawmapGridintoSec();
	drawNextBlockSec(QB);
	drawScoreintoSec(score);
	sprite_bag->draw(NUMARRAY,numlife,livesXtoscreenX(),livesYtoscreenY(),
		           DXManager.lpddsecondary);
	
	DXManager.Flip();
	
}

//-------------------------------------------------------------------

void drawNextBlockSec(QuadBlock nextblock) {

	for (int y = 0; y <= nextblock.spaceArray[nextblock.currentpos].maxY; y++) {
		for (int x = 0; x <= nextblock.spaceArray[nextblock.currentpos].maxX;x++)

			sprite_bag->draw(BLOCKS,nextblock.currentColorAt(x,y),
						 nxtblockXtoscreenX(x),nxtblockYtoscreenY(y),
						 DXManager.lpddsecondary);
			
	}	// end for y
}	// end drawNextBlockSec

//-----------------------------------------------------------------------------

void drawScoreintoSec(int score[MAXSCOREPOS]) {

	for (int index = MAXSCOREPOS-1; index >= 0; index--)
		sprite_bag->draw(NUMARRAY,score[index],scoreXtoscreenX(index),scoreYtoscreenY(),
		               DXManager.lpddsecondary);

}

//------------------------------------------------------------------------------

void addScore(int score[MAXSCOREPOS], int numfilled) {

	total_lines = total_lines + numfilled;

	score[0] = score[0] + pow(numfilled,numfilled);
	for (int i = 0;i<MAXSCOREPOS;i++) {
		score[i+1] = score[i+1] + (score[i]/10);
		score[i] = score[i]%10;
	}
}

//---------------------------------------------------------------------------------

void deleteRows(int numfilled, int filledrows[MAXMAPY]) {
	// this function is a weird one, but it deletes all the filled rows demarked
	// by the filledrows array, and then resets the values in the filledrows array
	// to account for the rows being shifted down.

	sounds_bag->play(CRUNCH);

	for (int index = numfilled-1; index >= 0; index--) {	// run through all filled rows

		mapGridArray.deleteOneRow(filledrows[index]);

					// delete current filled row
		filledrows[index-1] = filledrows[index-1]+(numfilled)-index;  // weird,
															// but it works.
	}
}

//-----------------------------------------------------------------------------------------------------------------

void pauseGame() {

	// this function basically delays the game until the pause
	// button is hit again.
	sounds_bag->pause(MUSIC);

	while (readPlayerInput() != PAUSE) ;

	sounds_bag->play(MUSIC,true);
	
}

//-------------------------------------------------------------------

void setBlocks(QuadBlock &top, QuadBlock &next) {

	top.copyQuadBlocks(quadarray[rand() % 7]);
	
	putTopBlockinGrid(top);
	
}

//-------------------------------------------------------------------

void dostartScreen() {

	SoundObject *super = NULL;
	SpriteImg_Object *start_menu = new SpriteImg_Object(1,640,480);

	super = new SoundObject();			// creates sound object for
										// intro	

	start_menu->load("start.bmp",0,0,DXManager.lpddsecondarypalette,
		               DXManager.lpddsprimarypalette);

	super->load("superhappy.wav");
	super->play();

	while (readPlayerInput() != PAUSE) {
		
		DXManager.clearsecsurface();
		start_menu->draw(0,0,0,DXManager.lpddsecondary);		
		DXManager.Flip();
	}

	super->stop();

	delete super;
	delete start_menu;
}

//-------------------------------------------------------------------

void doendScreen(int score[MAXSCOREPOS]) {
	
	SpriteImg_Object *endscreen = new SpriteImg_Object(1,640,480);

	endscreen->load("end.bmp",0,0,DXManager.lpddsecondarypalette,
		            DXManager.lpddsprimarypalette);	

	Sleep(200);

	while ((readPlayerInput() != PAUSE) && (readPlayerInput() != SHUTDOWN)){

		DXManager.clearsecsurface();
			for (int index = MAXSCOREPOS-1; index >= 0; index--)
				sprite_bag->draw(NUMARRAY,score[index],endscoreXtoscreenX(index),endscoreYtoscreenY(),
				               DXManager.lpddsecondary);
				
			endscreen->draw(0,0,0,DXManager.lpddsecondary);	  
	
			DXManager.Flip();
	}

	endscreen->Release();
	delete endscreen;

}  

//------------------------------------------------------------------

int gridYtoScreenY(int row) {return 1+ row * QBHEIGHT;}
int gridXtoScreenX(int column) { return 190 + column * QBWIDTH; }
int nxtblockYtoscreenY(int gridy) { return 117 + gridy * QBHEIGHT;}
int nxtblockXtoscreenX(int gridx) { return 400 + gridx * QBWIDTH;}
int scoreYtoscreenY() {return 256; }
int scoreXtoscreenX(int pos) { return 555 - pos * NUMWIDTH;}
int endscoreXtoscreenX(int pos) {return 381 - pos * NUMWIDTH;}
int endscoreYtoscreenY() {return 148;}
int livesYtoscreenY(){ return 331;}
int livesXtoscreenX(){ return 473;}

//-----------------------------------------------------------------------------
// time functions
DWORD current_time() { return GetTickCount(); }
DWORD new_next_time(int total_lines) {
	// this function calculates the amount of time between falls
	// by decrementing the time by a constant acceleration, per
	// every ten lines
	if (total_lines < 190)  // caps the falling rate at 20 bps
		return  (total_lines/10) * FALLING_ACCELERATION + START_FALL_CONSTANT; 
		else  return 50; }

//--------------------------------------------------------------------

void deletesounds() {

	// stop all sounds
	sounds_bag->stopAll();

	// reclaim memory from the sound objects
	sounds_bag->clearAll();

}