// Lucas Keyes
// source code for Sound Manager Object

#include "snd_managerobj.h"


Sound_ManagerObject::Sound_ManagerObject() {

	for (int i = 0; i < MAX_SOUNDS; i++)
		sound_array[i] = NULL;

	size = 0;
}

Sound_ManagerObject::~Sound_ManagerObject() {

	clearAll();

}


void Sound_ManagerObject::clear(int index) {

	if (index < size)  {// if valid location 

		if (sound_array[index] != NULL) {// contains a valid object
			
			sound_array[index]->clear();

	//	delete sound_array[index];
		}
	}

}

void Sound_ManagerObject::clearAll() {

	for (int index = 0; index < size; index++)
		clear(index);
}

bool Sound_ManagerObject::load(int index, char *filename, int copies) {

	if (index < MAX_SOUNDS) {	// can fit in array
		if (sound_array[index] == NULL) { // space is empty
			sound_array[index] = new SoundObject();
			sound_array[index]->load(filename,copies);

			if (index > size - 1)
				size = index + 1;

			return true;
		}
	}

	return false;
}

void Sound_ManagerObject::pause(int index) {

	if (index < size)	// if valid location
		if (sound_array[index] != NULL) // contains valid object
			sound_array[index]->pause();
}

void Sound_ManagerObject::pauseAll() {

	for (int index = 0; index < size; index++) {
		pause(index);
	}
}

void Sound_ManagerObject::play(int index, bool looping) {

	if (index < size) {	// contains a valid location
		if (sound_array[index] != NULL) // contains a valid object
			sound_array[index]->play(looping);

	}
}

void Sound_ManagerObject::stop(int index) {

	if (index < size) {	// contains a valid location
		if (sound_array[index] != NULL) // contains a valid object
			sound_array[index]->stop();
	}
}

void Sound_ManagerObject::stopAll() {

	for (int index = 0; index < size; index++)
		stop(index);
}