// Lucas Keyes
// soundobject.h
// this holds the SoundObject class, holds the data and 
// methods for a sound with no or multiple copies.

#ifndef __SOUNDOBJECT__
#define __SOUNDOBJECT__

#include "defines.h"
#include <dsound.h>

class SoundObject {


private:
	int numcopies;
	LPDIRECTSOUNDBUFFER *lpsound_buffer;

	BOOL CreateBuffer(int length, int copies);
	BOOL CopyBuffer(int copies);
	int LoadSound(char *filename, BYTE **sound);
	BOOL LoadBuffer(BYTE *buffer, int length);

public:
	SoundObject();
	~SoundObject();
	void clear();
	void load(char *filename, int copies = 1);
	void play(BOOL looping = FALSE);
	void stop();
	void pause();

};

#endif
